import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class LUPivotAdv extends Frame
{
   public LUPivotAdv()
   {  setSize(1000,500);
      addWindowListener(new WindowAdapter()
      {  public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
                                                          //sZ
   public double[][] MultM(double [][] A,double [][] B,int N1,int N2, int N3)
   {  int i,j,k;double[][] C = new double [N1][N3];
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public void CopyArray(double[][] A, double[][]R,int N) //z񕡎
   {  int i,j;
      for(i=0;i<N;i++) for(j=0;j<N;j++) R[i][j]=A[i][j];
   }
   public int LU_D_Pivot(double[][] A, double[][] LU,int [] Pivot,int N,double Eps)
   {  int i, j, k;
      CopyArray(A,LU,N); for(k=0;k<N;k++) Pivot[k]=k;
      for(k=0;k<N;k++)   // s{bgւ
      { i=k;
        for(j=k+1;j<N;j++) if(Math.abs(LU[Pivot[j]][k])>Math.abs(LU[Pivot[i]][k])) i=j;
        j = Pivot[k]; Pivot[k] = Pivot[i]; Pivot[i] = j;
        double PV = LU[Pivot[k]][k];
        if(Math.abs(PV)<Eps) return 1;
        for(i=k+1;i<N;i++)
        {  double T = LU[Pivot[i]][k] / PV; LU[Pivot[i]][k] = T;
           for(j=k+1;j<N;j++) LU[Pivot[i]][j] -= T * LU[Pivot[k]][j];
        }
      }
      return 0;
   }
   public void LUtoLandU(double[][] LU, double[][] L,double[][] U,int N)
   {  int i,j;
      for(i=0;i<N;i++) for(j=0;j<N;j++)
      {   if(j==i)     { U[i][j] = LU[i][j]; L[i][j] = 1       ;}
          else if(j>i) { U[i][j] = LU[i][j]; L[i][j] = 0       ;}
          else         { U[i][j] = 0       ; L[i][j] = LU[i][j];}
      }
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      if(Math.abs(D*DN)<0.5) return 0.0;
      return (Math.rint(D*DN))/DN;
   }
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,300,Y+20);
      g.drawString( ope2,600,Y+20);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         g.drawString( "" + round(B[i][j],3),350 + j*50,Y + i*20);
         g.drawString( "" + round(C[i][j],3),650 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,250, Y - 10, 70);
      drawBra(g,340, Y - 10, 70); drawKet(g,550, Y - 10, 70);
      drawBra(g,640, Y - 10, 70); drawKet(g,850, Y - 10, 70);
   } 
   public void DrawExp(Graphics g, String ope1,int Y,
                       double [][] A,double [][] B,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,300,Y+40);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         g.drawString( "" + round(B[i][j],3),350 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,250, Y - 10, 70);
      drawBra(g,340, Y - 10, 70); drawKet(g,540, Y - 10, 70);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A     ={{5,3,1,3},{4,4,2,2},{4,1,3,1},{1,2,2,5}};
      double [][] LU    ={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
      double [][] L     ={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
      double [][] U     ={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
      int    []   Pivot ={0,0,0,0};      
      setTitle("LUiPj");
      int R = LU_D_Pivot(A, LU, Pivot, 4, 0.00001);
      DrawExp(g, "", 50, A, LU, 4, 4);
      LUtoLandU(LU, L, U,4);
      double [][] D = MultM(L, U, 4, 4, 4);
      DrawExp(g, "","", 170, L, U, D, 4, 4);
   } 
   public static void main(String[] args)
   {  Frame w = new LUPivotAdv();
      w.setVisible(true);
   }
}